unit Unit2VCL;

//==============================================================================
//
//    INTERFACE
//
//==============================================================================
interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.ComCtrls, Vcl.StdCtrls,
  Vcl.Samples.Spin, VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series,
  VCLTee.TeeProcs, VCLTee.Chart, Vcl.Grids, Vcl.Samples.Calendar,
  Vcl.Imaging.jpeg, System.Actions, Vcl.ActnList, Vcl.Menus, Vcl.Imaging.GIFImg;

// Otras
const
  WM_AFTER_SHOW = WM_USER + 300; // custom message
  STR_EMPTY = '';
// Constantes WMI
const
  STR_LOCALHOST = '.';
  STR_CIM2_ROOT = 'root\cimv2';
  STR_CLASS     = 'Win32_DISKDRIVE';


type
  TForm2 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    edtHost: TEdit;
    edtIntervalo: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    edtReintentos: TSpinEdit;
    Timer1: TTimer;
    TrayIcon1: TTrayIcon;
    Image1: TImage;
    Label4: TLabel;
    LinkLabel1: TLinkLabel;
    Button1: TButton;
    Memo1: TMemo;
    Chart1: TChart;
    Series1: TLineSeries;
    btnUpdateGraph: TButton;
    MonthCalendar1: TMonthCalendar;
    Label5: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ActionList1: TActionList;
    ActionClose: TAction;
    PopupMenu1: TPopupMenu;
    Restaurar1: TMenuItem;
    ActionRestaurar: TAction;
    Close1: TMenuItem;
    btnGrabarImagen: TButton;
    N1: TMenuItem;
    miUltimo: TMenuItem;
    ActionGrabarGrafico: TAction;
    Grabargrfico1: TMenuItem;
    N2: TMenuItem;
    TabSheet3: TTabSheet;
    mmTODO: TMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtIntervaloChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrayIcon1DblClick(Sender: TObject);
    procedure btnUpdateGraphClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure MonthCalendar1Click(Sender: TObject);
    procedure ActionCloseExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActionRestaurarExecute(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure ActionGrabarGraficoExecute(Sender: TObject);
  private
    fName, dirName:string;
    ini:boolean;

    // Evento AfterShow
    procedure WmAfterShow(var Msg: TMessage); message WM_AFTER_SHOW;
    // Procedimiento para hacer PING a tgravs de WMI
    function Ping(const AHost:string;
                   var ResponseTime:integer; var StatusCode:integer):integer;
    // Obtiene el nombre de fichero a partir del da
    function GetDayFileName(ADate: TDate):string;
    // actualiza el grfico con los datos del da seleccionado en el calendario
    procedure UpdateGraphByDay(ADay:TDate);
    // Graba un fichero con los resultados de un da
    procedure SaveResult(AValue:integer);
  public
    { Public declarations }
  end;



var
  Form2: TForm2;

//==============================================================================
//
//    IMPLEMENTATION
//
//==============================================================================
implementation

{$R *.dfm}

uses
  ShellAPI, WbemScripting_TLB,
  ActiveX, System.AnsiStrings,
  ComObj;

// actualiza el grfico con los datos del da seleccionado en el calendario
procedure TForm2.UpdateGraphByDay(ADay:TDate);
var
  TS:TStrings;
  I: Integer;
  Str, StrDate, StrMin, StrTime:string;
  fn:string;
begin

  // Calcular el nombre a partir del da
  fn := GetDayFileName(ADay);

  // Ini
  Timer1.Enabled := False;
  TS := TStringList.Create();
  try
    Series1.Clear;

    // No existe?  => Salimos
    if not FileExists(fn) then begin
      Exit;
    end;
    // Cargar datos
    TS.LoadFromFile(fn);
    // Recorrer laslecturas
    for I := 0 to (TS.Count -1) do begin
      Str := TS[i];
      StrMin := Trim(Copy(Str, 12, 5));
      StrTime := Trim(Copy(Str, 21, 5));
      // Aadirlas al grfico
      Series1.Add(StrToFloat(StrTime), StrMin);
    end;

  finally
    TS.Free;
    Timer1.Enabled := True;
  end;
end;

procedure TForm2.ActionCloseExecute(Sender: TObject);
begin
  TrayIcon1.Visible := True;
  Self.Hide;
end;

// Grabar el grfico a fichero (JPG)
procedure TForm2.ActionGrabarGraficoExecute(Sender: TObject);
var
  tmpBitmap:TBitmap;
  jpg:TJPEGImage;
  fn:TFileName;
begin
  tmpBitmap := Chart1.TeeCreateBitmap;
  jpg := TJPEGImage.Create;
  try
    // set the desired JPEG options...
    jpg.CompressionQuality:=95;
    // Copy the temporary Bitmap onto the JPEG image...
    jpg.Assign(tmpBitmap);

    fn := GetDayFileName(MonthCalendar1.Date);

    // Grabar
    fn := ChangeFileExt(fName, '.jpg');
    jpg.SaveToFile(fn);
  finally
    tmpBitmap.Free;
    jpg.Free;
  end;

end;

procedure TForm2.ActionRestaurarExecute(Sender: TObject);
begin
  Self.Show;
  TrayIcon1.Visible := False;
end;

procedure TForm2.btnUpdateGraphClick(Sender: TObject);
begin
  UpdateGraphByDay(now);
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 0;
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 1;
end;

procedure TForm2.Close1Click(Sender: TObject);
var
  fn:TFileName;
begin
  Timer1.Enabled := False;
  ActionGrabarGrafico.Execute;

  // Leer Lista TODO
  fn := ChangeFileExt(Application.ExeName, '.todo');
  mmTODO.Lines.SaveToFile(fn);

  Application.Terminate;
end;

procedure TForm2.edtIntervaloChange(Sender: TObject);
begin
  Timer1.Enabled := False;
  Timer1.Interval := (edtIntervalo.Value * 1000);
  Timer1.Enabled := True;
end;

procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := False;
  ActionClose.Execute;
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  fn:TFileName;
begin
  ini := True;

  PageControl1.ActivePageIndex := 0;

  // fichero de log y directorio
  fName := FormatDateTime('yyyymmdd', now);
  dirName := IncludeTrailingBackslash(ExtractFileDir(Application.ExeName)) + 'LOG';
  fName := IncludeTrailingBackslash(dirName) + fName + '.log';

  // Leer Lista TODO
  fn := ChangeFileExt(Application.ExeName, '.todo');
  if FileExists(fn) then begin
    mmTODO.Lines.LoadFromFile(fn);
  end;

end;

procedure TForm2.FormShow(Sender: TObject);
begin
  // ini
  Timer1.Interval := (edtIntervalo.Value * 1000);
  Timer1.Enabled := True;

  // Post the custom message WM_AFTER_SHOW to our form
  PostMessage(Self.Handle, WM_AFTER_SHOW, 0, 0);
end;

// Obtiene el nombre de fichero a partir del da
function TForm2.GetDayFileName(ADate: TDate): string;
begin
  // fichero de log y directorio
  Result := FormatDateTime('yyyymmdd', ADate);
  dirName := IncludeTrailingBackslash(ExtractFileDir(Application.ExeName)) + 'LOG';
  Result := IncludeTrailingBackslash(dirName) + Result + '.log';
end;


procedure TForm2.MonthCalendar1Click(Sender: TObject);
begin
  UpdateGraphByDay(MonthCalendar1.Date);
end;


//SELECT * FROM Win32_PingStatus where Address="172.16.84.190" AND BufferSize=32
function TForm2.Ping(const AHost:string;
                      var ResponseTime:integer; var StatusCode:integer):integer;
var
  Locator:ISWbemLocator;
  Services:ISWbemServices;
  SObject:ISWbemObject;
  ObjSet:ISWbemObjectSet;
  Enum:IEnumVariant;
  TempObj:OleVariant;
  Value:Cardinal;
  TS:TStrings;
  tmp:string;
  aWSQL:string;

  //
  // Extrae de la respuesta WMI los datos necesarios
  procedure ParseDataResponse(InTS:TStrings; var AResponseTime:integer; var AStatusCode:integer);
  var
    Str, tmp:string;
    i, pos: Integer;
  begin
    // ini
    AResponseTime := -1;
    AStatusCode := -1;
    // Buscar los vaores que necesitamos
    for i := 0 to (InTS.Count - 1) do begin
      Str := Trim(InTS[i]);
      pos := AnsiPos('ResponseTime', Str);
      // encontrado?
      if (pos > 0) then begin
        pos := AnsiPos('=', Str);
        if (pos > 0) then begin
          tmp := Copy(Str, pos+1, Length(Str));
          tmp := AnsiReplaceText(tmp, ';', '');
          AResponseTime := StrToIntDef(tmp, -1);
        end;
      end;

      pos := AnsiPos('StatusCode', Str);
      // encontrado?
      if (pos > 0) then begin
        pos := AnsiPos('=', Str);
        if (pos > 0) then begin
          tmp := Copy(Str, pos+1, Length(Str));
          tmp := AnsiReplaceText(tmp, ';', '');
          StatusCode := StrToIntDef(tmp, -1);
        end;
      end;
    end;
  end;
  //
begin

  // SQL de consulta
  aWSQL := 'SELECT ResponseTime, StatusCode FROM Win32_PingStatus where Address="' + AHost + '" AND BufferSize=32';

  try
    Locator := CoSWbemLocator.Create();
    // Conectar con el Servicio de WMI
    Services := Locator.ConnectServer(
        STR_LOCALHOST,        {ordenador local}
        STR_CIM2_ROOT,        {root}
        STR_EMPTY, STR_EMPTY, {usuario y password -en local no son necesarios-}
        STR_EMPTY,STR_EMPTY, 0, nil);
    // Acceder a los datos
    ObjSet := Services.ExecQuery(aWSQL, 'WQL',
                wbemFlagReturnImmediately and wbemFlagForwardOnly , nil);
    Enum :=  (ObjSet._NewEnum) as IEnumVariant;
    // Hemos encontrado algun objeto?
    if (Enum.Next(1, TempObj, Value) = S_OK) then begin
      SObject := IUnknown(TempObj) as ISWBemObject;
      // encontrado?
      if (SObject <> nil) then begin
        // Acceder a la propiedad
        SObject.Properties_;
        // Cargamos las propiedades
        TS := TStringList.Create();
        try
          //TS.Add(SObject.GetObjectText_(0));
          TS.Text := SObject.GetObjectText_(0);
          // Devolvemos los valores que nos interesan
          // Extraer los datos que necesitamos
          ParseDataResponse(TS, ResponseTime, StatusCode);

        finally
          FreeAndNil(TS);
        end;
      end;
    end;
  except
    // Recuperar excepciones
  end;
end;

// Graba un fichero con los resultados de un da
procedure TForm2.SaveResult(AValue:integer);
var
  TS:TStrings;
  Str:String;
begin

  // No existe el directorio?
  if not DirectoryExists(dirName) then begin
    ForceDirectories(dirName);
  end;

  // Crear la estructura
  TS := TStringList.Create();
  try
    // Nombre de fichero?
    fName := GetDayFileName(now);
    // Existe el fichero?
    if FileExists(fName) then begin
      TS.LoadFromFile(fName);
    end;
    // Aadir el nuevo valor
    Str := FormatDateTime('yyyy/mm/dd hh:nn:ss ' + IntToStr(AValue), now);
    TS.Add(Str);

    // Grabar
    TS.SaveToFile(fName);

  finally
    TS.Free;
  end;

end;



procedure TForm2.Timer1Timer(Sender: TObject);
begin
  Self.Button1Click(nil);
end;

procedure TForm2.TrayIcon1DblClick(Sender: TObject);
begin
  ActionRestaurar.Execute;
end;

procedure TForm2.WmAfterShow(var Msg: TMessage);
begin
  // Tray
  if (ini) then begin
    ini := False;
    TrayIcon1.Visible := True;
    Self.Hide;
  end;

  UpdateGraphByDay(now);

end;

procedure TForm2.Button1Click(Sender: TObject);
var
  RespTime, Status:integer;
begin


  try
    CoInitialize(nil);
    try
      // realizar el PING
      Ping(edtHost.Text, RespTime, Status);
      // Debug
      Memo1.Lines.Add('Host: ' + edtHost.Text);
      Memo1.Lines.Add('  RespTime: ' + IntToStr(RespTime));
      Memo1.Lines.Add('  StatusCode: ' + IntToStr(Status));

      // save Result on lOg
      SaveResult(RespTime);

    finally
      CoUninitialize;
    end;
 except
    on E:Exception do
        Memo1.Lines.Add(E.Classname + ':' + E.Message);
 end;

end;

end.
